Subject: Re: [PATCH net-next 01/15] net: dsa: provide an option for drivers to always receive bridge VLANs

From: Russell King - ARM Linux admin <[email-masked]>
Date: Mon, 11 May 2020 12:54:12 +0100

On Mon, May 11, 2020 at 02:40:29PM +0300, Vladimir Oltean wrote:
> On Mon, 11 May 2020 at 14:38, Russell King - ARM Linux admin
> <[email-masked]> wrote:
> >
> > On Sun, May 10, 2020 at 07:42:41PM +0300, Vladimir Oltean wrote:
> > > From: Russell King <[email-masked]>
> > >
> > > DSA assumes that a bridge which has vlan filtering disabled is not
> > > vlan aware, and ignores all vlan configuration. However, the kernel
> > > software bridge code allows configuration in this state.
> > >
> > > This causes the kernel's idea of the bridge vlan state and the
> > > hardware state to disagree, so "bridge vlan show" indicates a correct
> > > configuration but the hardware lacks all configuration. Even worse,
> > > enabling vlan filtering on a DSA bridge immediately blocks all traffic
> > > which, given the output of "bridge vlan show", is very confusing.
> > >
> > > Provide an option that drivers can set to indicate they want to receive
> > > vlan configuration even when vlan filtering is disabled. At the very
> > > least, this is safe for Marvell DSA bridges, which do not look up
> > > ingress traffic in the VTU if the port is in 8021Q disabled state. It is
> > > also safe for the Ocelot switch family. Whether this change is suitable
> > > for all DSA bridges is not known.
> > >
> > > Signed-off-by: Russell King <[email-masked]>
> > > Signed-off-by: Vladimir Oltean <[email-masked]>
> >
> > This patch was NAK'd because of objections to the "vlan_bridge_vtu"
> > name.  Unfortunately, this means that the bug for Marvell switches
> > remains unfixed to this day.
> >
> 
> How about "accept_vlan_while_unaware"?

It's up to DSA maintainers.

However, I find that rather confusing. What's "unaware"? The point of
this boolean is to program the vlan tables while vlan filtering is
disabled. "accept_vlan_while_vlan_filtering_disabled" is way too long.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTC broadband for 0.8mile line in suburbia: sync at 10.2Mbps down 587kbps up